var lsos = [];
var deletedLsos = [];
var lsosTree;
var count = 0;

var lsosTreeView = {
  rowCount : 0,
  setTree : function(tree){},
  getImageSrc : function(row,column) {},
  getProgressMode : function(row,column) {},
  getCellValue : function(row,column) {},
  getCellText : function(row,column){
    var rv="";
    if (column=="parentCol") {
      rv = lsos[row].parent;
    } else if (column=="nameCol") {
      rv = lsos[row].name;
    }
    return rv;
  },
  isSeparator : function(index) {return false;},
  isSorted: function() { return false; },
  isContainer : function(index) {return false;},
  cycleHeader : function(aColId, aElt) {},
  getRowProperties : function(row,column,prop){},
  getColumnProperties : function(column,columnElement,prop){},
  getCellProperties : function(row,prop){}
 };

function Lso(number,file,name,size,path,parent) {
  this.number = number;
  this.file = file;
  this.name = name;
  this.size = size;
  this.path = path;
  this.parent = parent;
  return this;
}

function objection_init() {
  
  var objectStrings = document.getElementById("lsoStrings");
  // why does the 'clear all' button on the privacy panel lack an 'id' tag?
  var allButton = document.getElementsByAttribute("oncommand","PrivacyPanel.clearAll();");
  allButton.item(0).setAttribute("oncommand","clearAllPlus();");
  var lsowatch = document.getElementById("lsos");
  lsowatch.addEventListener("clear", lsoclear_init, false);
  if (GetFlashDir() == "") {
    document.getElementById("appdir").value = objectStrings.getString("dirNotFound");;
  } else {
    document.getElementById("appdir").value = GetFlashDir().path;
  }
}

// automatic detection for Flash Apps directory
function GetFlashDir() {
  var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection.");
  var LocalFile = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile");
  var flashDir = new LocalFile();
  var varDir = new LocalFile();
  if ((!objectionPrefs.prefHasUserValue("flashAppDir"))||(typeof(objectionPrefs.getCharPref("flashAppDir")) == 'undefined')) {
    if (window.navigator.platform == "Win32") {
      var winDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("AppData", Components.interfaces.nsILocalFile);
      flashDir = winDir;
      flashDir.appendRelativePath('\Macromedia');
      flashDir.appendRelativePath('\Flash Player');
      if ((flashDir.exists()) && (flashDir.isDirectory())) {
        varDir = flashDir;
        objectionPrefs.setCharPref("flashAppDir", varDir.path);
      } else {
        flashDir = winDir;
        flashDir.appendRelativePath('\Macromedia');
        if ((flashDir.exists()) && (flashDir.isDirectory())) {
          varDir = flashDir;
          objectionPrefs.setCharPref("flashAppDir", varDir.path);
        } else {
            varDir = "";
            objectionPrefs.setCharPref("flashAppDir", "");
          }
        }
      } else if (window.navigator.platform == "MacPPC") {
        var macDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("UsrPrfs", Components.interfaces.nsILocalFile);
        flashDir = macDir;
        flashDir.appendRelativePath('Macromedia');
        flashDir.appendRelativePath('Flash Player');
        if ((flashDir.exists()) && (flashDir.isDirectory())) {
          varDir = flashDir;
          objectionPrefs.setCharPref("flashAppDir", varDir.path);
        } else {
          flashDir = macDir;
        flashDir.appendRelativePath('\Macromedia');
        if ((flashDir.exists()) && (flashDir.isDirectory())) {
          varDir = flashDir;
          objectionPrefs.setCharPref("flashAppDir", varDir.path);
        } else {
            varDir = ""; 
            objectionPrefs.setCharPref("flashAppDir", "");
          }
        }
      } else {
        var homeDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("Home", Components.interfaces.nsILocalFile);
        flashDir = homeDir;
        flashDir.appendRelativePath('.macromedia');
        flashDir.appendRelativePath('Macromedia');
        flashDir.appendRelativePath('Flash \Player');
        if ((flashDir.exists()) && (flashDir.isDirectory())) {
          varDir = flashDir;
          objectionPrefs.setCharPref("flashAppDir", varDir.path);
        } else {
          flashDir = homeDir;
          flashDir.appendRelativePath('.macromedia');
          flashDir.appendRelativePath('Macromedia');
          if ((flashDir.exists()) && (flashDir.isDirectory())) {
            varDir = flashDir;
            objectionPrefs.setCharPref("flashAppDir", varDir.path);
          } else {
            varDir = "";
            objectionPrefs.setCharPref("flashAppDir", ""); 
          }
        }  
      }  
  } else {
    if (objectionPrefs.getCharPref("flashAppDir") != "") {
      varDir.initWithPath(objectionPrefs.getCharPref("flashAppDir"));
    } else varDir = "";
  }
  return varDir;
}

function lsoclear_init() {
  var objectStrings = document.getElementById("lsoStrings");
  if (document.getElementById("appdir").value == objectStrings.getString("dirNotFound")) {
    alert(objectStrings.getString("notFoundDesc"));
  } else {
    var flashDir = GetFlashDir();
    clearLSOs(flashDir);
  }
}

function InitLsoLoad() {
  var flashDir = GetFlashDir();
  var viewerStrings = document.getElementById("lsoStrings");
  loadLsos(flashDir);
}

function clearLSOs(someDir) { 

  var dirIterator = someDir.directoryEntries;
  var currentFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  var directoriesArray = new Array();
  var mode = 'clear';
  
  while (dirIterator.hasMoreElements) {
    var currentFile = dirIterator.getNext();
    if (currentFile) {
      currentFile.QueryInterface(Components.interfaces.nsILocalFile);
      if (currentFile.isFile()) {
        var leaf  = currentFile.leafName;
        var dotIndex  = leaf.lastIndexOf('.');
        var extension = (dotIndex >= 0) ? leaf.substring(dotIndex+1) : "";
        if ((extension == "sol")||(extension == "fso")) {
          currentFile.remove(false);
        }
      } else if (currentFile.isDirectory()) {
        directoriesArray.push(currentFile);
      }
    } else break;
  }
  arrayProcess(directoriesArray, mode);
  document.getElementById("lsos").setAttribute("cleardisabled", true);
}  
  
function arrayProcess(directoriesArray, mode) {
  for (var q = 0; q < directoriesArray.length; q++) {
    if (mode == 'clear') {
      clearLSOs(directoriesArray[q]);
    }
    if (mode == 'load') {
      loadLsos(directoriesArray[q]);
    }
  }
}

function clearAllPlus() {
  var privacyBundle = document.getElementById("privacyBundle");
  var title = privacyBundle.getString("prefRemoveAllTitle");
  var msg = privacyBundle.getString("prefRemoveAllMsg");
  var button = privacyBundle.getString("prefRemoveAllRemoveButton");
  
  if (PrivacyPanel.confirm(title, msg, button)) {
    lsoclear_init();
    for (var fn in PrivacyPanel.clearData) {
      PrivacyPanel.clearData[fn](false);
      document.getElementById(fn).setAttribute("cleardisabled", "true");
    }
  }
}

function viewLsos() {
  var objectStrings = document.getElementById("lsoStrings");
  if (document.getElementById("appdir").value == objectStrings.getString("dirNotFound")) {
    alert(objectStrings.getString("notFoundDesc"));
  } else {
    window.openDialog("chrome://objection/content/LsoViewer.xul","_blank","chrome,resizable=yes", "lsoManager");
  }
}

function GetFields() {
  var dataObject = {};
  dataObject.deletedLsos = deletedLsos;
  dataObject.lsos = lsos;
  return dataObject;
}

function SetFields(dataObject) {
  if ('lsos' in dataObject)
    lsos = dataObject.lsos;
  if ('deletedLsos' in dataObject)
    deletedLsos = dataObject.deletedLsos;
}

function loadLsos(flashDir) {
  var loadIterator = flashDir.directoryEntries;
  var currentFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  var directoriesArray = new Array();
  var mode = 'load';
  
  if (!lsosTree) {
    lsosTree = document.getElementById("lsosTree");
  }
  
  while (loadIterator.hasMoreElements) {
    var currentFile = loadIterator.getNext();
    if (currentFile) {
      currentFile.QueryInterface(Components.interfaces.nsILocalFile);
      if (currentFile.isFile()) {
        var leaf  = currentFile.leafName;
        var dotIndex  = leaf.lastIndexOf('.');
        var extension = (dotIndex >= 0) ? leaf.substring(dotIndex+1) : "";
        if ((extension == "sol")||(extension == "fso")) {
          lsos[count] = new Lso(count++,currentFile,currentFile.leafName,currentFile.fileSize,currentFile.path,currentFile.parent.leafName);
        }
      } else if (currentFile.isDirectory()) {
        directoriesArray.push(currentFile);
      }
    } else break;
  }
  arrayProcess(directoriesArray, mode);
  lsosTreeView.rowCount = lsos.length;
  lsosTree.treeBoxObject.view = lsosTreeView;
  LsoColumnSort('parent');
  document.getElementById("removeAllLsos").disabled = lsos.length == 0;
}

function onOK() { }

function HandleLsoKeyPress(e) {
  if (e.keyCode == 46) {
    DeleteLso();
  }
}

function LsoSelected() {
  var selections = GetTreeSelections(lsosTree);
  if (selections.length) {
    document.getElementById("removeLso").removeAttribute("disabled");
  } else { return true; }
  
  var indexvar = selections[0];
  if (indexvar >= lsos.length) {
    // Something got out of synch.  See bug 119812 for details
    dump("Out of synch; see Mozilla bug 119812 to help.");
    return;
  }
  
  var props = [
    {id: "lso_name", value: lsos[indexvar].name},
    {id: "lso_parent", value: lsos[indexvar].parent}, 
    {id: "lso_size", value: lsos[indexvar].size},
    {id: "lso_path", value: lsos[indexvar].path},
  ];

  var value;
  var field;
  for (var i = 0; i < props.length; i++)
  {
    field = document.getElementById(props[i].id);
    if (selections.length > 1) {
      value = "";
    } else {
      if (props[i].id == "lso_size") {
        value = props[i].value + " bytes";
      } else { value = props[i].value; }
    }
    field.value = value;
  }
  return true;
}

var lastLsoSortColumn = "";
var lastLsoSortAscending = false;

function LsoColumnSort(column) {
  lastLsoSortAscending =
    SortTree(lsosTree, lsosTreeView, lsos,
                 column, lastLsoSortColumn, lastLsoSortAscending);
  lastLsoSortColumn = column;
}

function ClearLsoProperties() {
  var properties = 
    ["lso_name","lso_parent","lso_path","lso_size"];
  for (var prop=0; prop<properties.length; prop++) {
    document.getElementById(properties[prop]).value = "";
  }
}

function DeleteLso() {
  var toDelete = GetTreeSelections(lsosTree);
  for (var x=0; x<toDelete.length; x++) {
    lsos[toDelete[x]].file.remove(false);
  }
  DeleteSelectedItemFromTree(lsosTree, lsosTreeView,
                                 lsos, deletedLsos,
                          "removeLso", "removeAllLsos");
  if (!lsos.length) {
    ClearLsoProperties();
  }
}

function DeleteAllLsos() { 
  for (var x=0; x<lsos.length; x++) {
    lsos[x].remove(false);
  }
  ClearLsoProperties();
  DeleteAllFromTree(lsosTree, lsosTreeView,
                        lsos, deletedLsos,
                 "removeLso", "removeAllLsos");
}

function changeAppDir() {
  var objectStrings = document.getElementById("lsoStrings");
  const nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, objectStrings.getString("selectDirTitle"), nsIFilePicker.modeGetFolder);
  var rv = fp.show();
  if (rv == nsIFilePicker.returnOK) {
    var file = fp.file;
    var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection.");
    objectionPrefs.setCharPref("flashAppDir", file.path);
    document.getElementById("appdir").value = file.path;
  }
}
